posts - 68, comments - 19, trackbacks - 0, articles - 1

多版本tomcat共存问题

Posted on 2011-02-24 00:09 viery 阅读(1196) 评论(0)  编辑  收藏
  • 问题描述:
启动Tomcat 6.0.x时, 报如下错误:
java.lang.NoSuchMethodError: javax.servlet.ServletContext.getContextPath()Ljava/lang/String;

网上google了一下,发现出这类问题的人很多.而且基本上都是原来装了Tomcat 5.5, 现在新下载了Tomcat 6.0,装上却出现这个错误.

  • 分析原因:
1. javax.servlet.ServletContext为servlet-api.jar内的类,通过反编译,发现Tomcat 6.0以前的版本的servlet-api.jar内的ServletContext类没有getContextPath()方法,而新的Tomcat 6.0及以后版本有这个方法,而且server 启动时需要调用这个方法
Tomcat 6.0 before
public interface ServletContext
{
    public abstract ServletContext getContext(String s);
Tomcat 6.0 later
public interface ServletContext
{

    public abstract ServletContext getContext(String s);

    public abstract String getContextPath();

2. 显然,Tomcat 6.0启动的时候错调用了别的版本的servlet-api.jar
为什么出现这种情况呢?
我分析情况大概如此:
肯定很多人硬盘上还有老版本的Tomcat , 按说多个版本的Tomcat是能在一个环境里共存的.
但很多人出于一些特殊原因(比如命令行javac下测试application级别的servlet),曾把以前版本的Tomcat的servlet-api.jar文件拷贝入%JRE%\lib\ext下 (JDK 引入第三方JAR文件都放在此目录下)
而Tomcat 启动是需要从%JAVA_HOME%和%JRE_HOME%读jar文件,而且从优先顺序下,JRE库是先于Tomcat自己的lib目录的


最终解决办法:
删除掉%JRE%\lib\ext下的servlet-api.jar文件,或者用Tomcat 6.0自己的servlet-api.jar覆盖
再重启Tomcat 6.0, 正常启动问题消失.

只有注册用户登录后才能发表评论。


网站导航: